import es, gamethread, random, effectlib, playerlib, services, os.path, cPickle, popuplib

### Start Config ###
colors = [[255, 0, 0], [0, 0, 255], [0, 255, 0], [255, 0, 255], [255, 255, 0], [0, 255, 255]] # RGB Color values of lasers
length_min = 50 # Minimum game units for laser
length_max = 350 # Maximum game units for laser
x_spin = 10 # How many degrees the ball spins on x axis every 0.1 seconds
y_spin = 10 # ""
z_spin = 10 # ""
# If mani_admins is in there, anyone in mani_admins can use it and anyone with disco_admin access if you have group auth set up may use it
admins = ['STEAM_0:0:20394923', 'STEAM_0:0:11089864', 'mani_admins']
disco_fog_change_time = 2 # Time between fog changes color
fog_start_unit = 150 # How many units away from the persons screen they see the fog, the large it is, the less you see
fog_end_unit = 1000 # How many units away from the person the fog stops
enable_fog = 1 # Enable/Disable the colored fog
custom_sound = None # If not none, you can have custom sounds playing with disco so an example would be 'cow.wav' and you would have to put cow.wav under cstrike/sound/disco/
downloads = [] # put all extra sounds in here, an example would be downloads = ['cow.wav', 'cow.mp3']
above_head_amount = 10 # The amount of game units above your head the disco will be if you specify "head"
disco_on_map_end = 0 # If 1, if there's any coordinates set with disco menu, and you have es tools disco will play. It'd be best to set mp_chattime high if you're doing this.
### End Config ###

index, start_userid, prop_keys, origin, disco_time = None, None, None, None, None

es.ServerVar('disco_version', 2.5, 'Disco made by Bonbon AKA Bonbon367').makepublic()

coords = {}

def load():
	if not es.exists('clientcommand', 'disco'):
		es.regclientcmd('disco', 'disco/disco')
	if not es.exists('clientcommand', 'stop_disco'):
		es.regclientcmd('stop_disco', 'disco/stop_stuff2')
	if not es.exists('clientcommand', 'disco_save_loc'):
		es.regclientcmd('disco_save_loc', 'disco/enter_loc')
	if not es.exists('command', 'disco'):
		es.regcmd('disco', 'disco/disco_server')
	add_sounds()
	coords_db = es.getAddonPath('disco') + '/coords.db'
	if os.path.isfile(coords_db):
		global coords
		moo = open(coords_db)
		coords = cPickle.load(moo)
		moo.close()

def unload():
	stop_stuff()
	if es.exists('clientcommand', 'disco'):
		es.unregclientcmd('disco')
	if es.exists('clientcommand', 'stop_disco'):
		es.unregclientcmd('stop_disco')
	if es.exists('clientcommand', 'disco_save_loc'):
		es.unregclientcmd('disco_save_loc')

def es_map_start(ev):
	add_sounds()

def disco_server():
	if not es.getuserid():
		es.dbgmsg(0, 'No players, cannot continue!')
		return

	disco3()

def disco():
	disco3(es.getcmduserid())

def disco3(userid=None):
	global origin, prop_keys, start_userid, disco_time
	server = False
	if is_authed(userid):
		xyz = False
		if len(es.getargs().split(' ')) >= 3:
			xyz = True if sum([1 if es.getargs().split(' ')[x].replace('.', '').replace('-', '').isdigit() else 0 for x in [0, 1, 2]]) == 3 else False

		if not userid:
			userid = es.getuserid()
			server = True

		prop_keys = list(es.createentitylist().keys())
		if not es.getargv(1).lower() in ['head', 'view', 'time', 'sound', 'menu'] and not xyz:
			if not server:
				es.tell(userid, '#multi', '#greenInvalid syntax -- #lightgreendisco <x> <y> <z>#green You can get your x y and z by typing #lightgreencl_showpos 1#green in console')
				es.tell(userid, '#green', 'The z is the height, you would probably want to have that at least 120 units above what is shown by cl_showpos 1')
				es.tell(userid, '#multi', '#greenAlternitivly, you can type #lightgreen disco head#green for it to appear above your head, or #lightgreen disco view#green for it to happen where you look')
				es.tell(userid, '#multi', '#greenYou can also type #lightgreendisco time <time>#green for the disco to appear above your head for <time> seconds')
				es.tell(userid, '#multi', '#greenYou can type #lightgreendisco sound <sound>#green for disco above your head with <sound> and #lightgreendisco menu#green for a menu')
			else:
				for a in ['Invalid syntax', 'Valid syntax are: disco <x> <y> <z>, disco head, disco sound <sound>, disco sound <sound> <x> <y> <z>, disco time <time>']:
					es.dbgmsg(0, a)
			return

		if not es.getargv(1).lower() == 'menu':
			start_userid = userid
			stop_stuff()

		if not playerlib.getPlayerList('#alive'):
			es.dbgmsg(0, 'No alive players, can not continue!')
			return

		if xyz:
			origin = map(float, es.getargs().split(' '))
			es.server.queuecmd('es_prop_dynamic_create %s roller_spikes.mdl'%userid)
			gamethread.delayed(0.05, do_stuff, (userid, 0))

		elif es.getargv(1).lower() == 'head':
			x, y, z = es.getplayerlocation(userid)
			origin = [float(x), float(y), float(z) + 120 + above_head_amount]
			es.server.queuecmd('es_prop_dynamic_create %s roller_spikes.mdl'%userid)
			gamethread.delayed(0.05, do_stuff, (userid, 0))

		elif es.getargv(1).lower() == 'view':
			es.server.queuecmd('es_prop_dynamic_create %s roller_spikes.mdl'%userid)
			gamethread.delayed(0.05, do_stuff, (userid, 1))

		elif es.getargv(1).lower() == 'time':
			dtime = es.getargv(2)
			if len(es.getargs().split(' ')) < 2:
				dtime = 90

			if not str(dtime).isdigit():
				dtime = 90

			x, y, z = es.getplayerlocation(userid)
			origin = [float(x), float(y), float(z) + 120 + above_head_amount]
			disco_time = float(dtime)
			es.server.queuecmd('es_prop_dynamic_create %s roller_spikes.mdl'%userid)
			gamethread.delayed(0.05, do_stuff, (userid, 2))
	
		elif es.getargv(1).lower() == 'sound':
			sound = es.getargv(2)
			if len(es.getargs().split(' ')) < 2:
				sound = 'woofwoof'

			if len(es.getargs().split(' ')) == 5:
				x, y, z = map(float, es.getargs().split(' ')[2:])
			else:
				x, y, z = es.getplayerlocation(userid)

			origin = [float(x), float(y), float(z) + 120 + above_head_amount]
			es.server.queuecmd('es_prop_dynamic_create %s roller_spikes.mdl'%userid)
			gamethread.delayed(0.05, do_stuff, (userid, 0, sound))

		elif es.getargv(1).lower() == 'menu':
			if server:
				es.dbgmsg(0, 'Can not use disco menu via server console!')
				return

			moo_cow = popuplib.easymenu('Disco', '_popup_choice', disco_menu)
			for disco_option in ['Start', 'Stop', 'Save Loc', 'Delete Loc']:
				moo_cow.addoption(disco_option, disco_option)
			popuplib.send('Disco', userid)

def disco_menu(userid, choice, popupid):
	if choice == 'Start':
		if coords.has_key(str(es.ServerVar('eventscripts_currentmap'))):
			menu = popuplib.easymenu('Choose Loc', '_popup_userid', choose_loc)
			map = coords[str(es.ServerVar('eventscripts_currentmap'))]
			for place in map:
				menu.addoption(map[place], place)
			popuplib.send('Choose Loc', userid)
		else:
			es.tell(userid, '#multi', '#greenSorry, the map #lightgreen%s #green doesn\'t have any coords saved, please save some!'%str(es.ServerVar('eventscripts_currentmap')))
	elif choice == 'Stop':
		es.cexec(userid, 'stop_disco')
	elif choice == 'Save Loc':
		es.escinputbox(30, userid, 'Choose Location Name', 'Please choose a name you want to call this location', 'disco_save_loc')
		es.tell(userid, '#green', 'Press escape on your keyboard to enter a name you want to call your location')
	elif choice == 'Delete Loc':
		if coords.has_key(str(es.ServerVar('eventscripts_currentmap'))):
			menu = popuplib.easymenu('Delete Loc', '_popup_userid', delete_loc)
			map = coords[str(es.ServerVar('eventscripts_currentmap'))]
			for place in map:
				menu.addoption(place, place)
			popuplib.send('Delete Loc', userid)

def delete_loc(userid, choice, popupid):
	del coords[str(es.ServerVar('eventscripts_currentmap'))][choice]

def enter_loc():
	userid = es.getcmduserid()
	if is_authed(userid):
		global coords
		if not coords.has_key(str(es.ServerVar('eventscripts_currentmap'))):
			coords[str(es.ServerVar('eventscripts_currentmap'))] = {}
		map = coords[str(es.ServerVar('eventscripts_currentmap'))]
		map[es.getargs()] = es.getplayerlocation(userid)
		es.tell(userid, '#green', 'Added %s to map locations'%(es.getargs()))
		save_data()

def choose_loc(userid, choice, popupid):
	es.cexec(userid, 'disco %s %s %s'%tuple(x for x in choice))

def is_authed(userid):
	if userid is None:
		return True
	if isAuthed(userid) or es.getplayersteamid(userid) in admins or (es.getplayersteamid(userid) in return_admins() and 'mani_admins' in admins):
		return True
	else:
		es.tell(userid, '#green', 'You are not authorized to run the command disco!')

def do_stuff(userid, view, sound=None):
	global index
	for prop in list(es.createentitylist().keys()):
		if not prop in prop_keys:
			index = int(prop)
	if not view:
		es.setindexprop(index, 'CBaseEntity.m_vecOrigin', '%s,%s,%s'%(origin[0], origin[1], origin[2]))
	elif view == 2:
		gamethread.delayedname(disco_time, 'timed_stop', stop_stuff)
		es.setindexprop(index, 'CBaseEntity.m_vecOrigin', '%s,%s,%s'%(origin[0], origin[1], origin[2]))
	else:
		global origin
		x, y, z = es.getindexprop(index, 'CBaseEntity.m_vecOrigin').split(',')
		origin = [float(x), float(y), float(z)]
	disco2()
	spin(index)
	if enable_fog:
		es.server.queuecmd('es_xgive %s env_fog_controller'%userid)
		es.server.queuecmd('es_xfire %s env_fog_controller addoutput \"fogdir %s %s %s\"'%(userid, 100, 100, 100))
		es.server.queuecmd('es_xfire %s env_fog_controller addoutput \"fogstart %s\"'%(userid, fog_start_unit))
		es.server.queuecmd('es_xfire %s env_fog_controller addoutput \"fogend %s\"'%(userid, fog_end_unit))
		es.server.queuecmd('es_xfire %s env_fog_controller addoutput \"fogblend 1"'%userid)
		es.server.queuecmd('es_xfire %s env_fog_controller addoutput \"fogcolor 100 100 100\"'%userid)
		es.server.queuecmd('es_xfire %s env_fog_controller addoutput \"fogcolor2 150 150 150\"'%userid)
		es.server.queuecmd('es_xfire %s env_fog_controller turnon'%userid)
		gamethread.delayedname(disco_fog_change_time, 'change_fog', change_fog_color)
	for sound_userid in es.getUseridList():
		if custom_sound and not sound:
			es.cexec(sound_userid, 'play disco/%s'%(custom_sound if type(custom_sound) == str else random.choice(custom_sound)))
		else:
			es.cexec(sound_userid, 'play disco/%s'%sound)

def change_fog_color():
	r, g, b = random.choice(colors)
	r2, g2, b2 = random.choice(colors)
	es.server.queuecmd('es_xfire %s env_fog_controller addoutput \"fogcolor %s %s %s\"'%(start_userid, r, g, b))
	es.server.queuecmd('es_xfire %s env_fog_controller addoutput \"fogcolor2 %s %s %s\"'%(start_userid, r2, g2, b2))
	gamethread.delayedname(disco_fog_change_time, 'change_fog', change_fog_color)

def round_end(ev):
	stop_stuff()

def stop_stuff2():
	if index:
		if str(index) in es.createentitylist() or int(index) in es.createentitylist():
			es.server.queuecmd('es_xremove %s'%index)

	if not is_authed(es.getcmduserid()):
		es.tell(es.getcmduserid(), '#green', '>:[')
		return
	stop_stuff()

def stop_stuff():
	gamethread.cancelDelayed('disco1')
	gamethread.cancelDelayed('spin_ball')
	gamethread.cancelDelayed('change_fog')
	gamethread.cancelDelayed('timed_stop')
	es.server.queuecmd('es_xfire %s env_fog_controller turnoff'%es.getuserid())
	es.server.queuecmd('es_xfire %s env_fog_controller kill'%es.getuserid())
	for suserid in es.getUseridList():
		es.cexec(suserid, 'play cow')

def disco2():
	r, g, b = random.choice(colors)
	x, y, z = origin
	x2 = x + random.randint(length_min, length_max) * random.choice([-1, 1])
	y2 = y + random.randint(length_min, length_max) * random.choice([-1, 1])
	z2 = z + random.randint(length_min, length_max) * random.choice([-1, 1])
	x3, y3, z3 = es.getplayerlocation(random.choice(playerlib.getUseridList('#alive')))
	if not random.randint(0, 2) == 0:
		effectlib.drawLine([x, y, z], [x2, y2, z2], "materials/sprites/laser.vmt", "materials/sprites/halo01.vmt", random.randint(1, 10) / 10.0, random.randint(1, 10), random.randint(1, 25), r, g, b, 255, 10, 0, 0, 0, 0)
		effectlib.drawLine([x, y, z], [x2 + 5, y2 + 5, z2], "materials/sprites/laser.vmt", "materials/sprites/halo01.vmt", random.randint(1, 10) / 10.0, random.randint(1, 10), random.randint(1, 25), r, g, b, 255, 10, 0, 0, 0, 0)
		effectlib.drawLine([x, y, z], [x2 + 5, y2, z2], "materials/sprites/laser.vmt", "materials/sprites/halo01.vmt", random.randint(1, 10) / 10.0, random.randint(1, 10), random.randint(1, 25), r, g, b, 255, 10, 0, 0, 0, 0)
	else:
		effectlib.drawLine([x, y, z], [x3, y3, z3], "materials/sprites/laser.vmt", "materials/sprites/halo01.vmt", random.randint(1, 10) / 10.0, random.randint(1, 10), random.randint(1, 25), r, g, b, 255, 10, 0, 0, 0, 0)
		effectlib.drawLine([x, y, z], [x3 + 5, y3 + 5, z3], "materials/sprites/laser.vmt", "materials/sprites/halo01.vmt", random.randint(1, 10) / 10.0, random.randint(1, 10), random.randint(1, 25), r, g, b, 255, 10, 0, 0, 0, 0)
		effectlib.drawLine([x, y, z], [x3 + 5, y3, z3], "materials/sprites/laser.vmt", "materials/sprites/halo01.vmt", random.randint(1, 10) / 10.0, random.randint(1, 10), random.randint(1, 25), r, g, b, 255, 10, 0, 0, 0, 0)
	gamethread.delayedname(random.randint(1, 5) / 25.0, 'disco1', disco2)


def spin(index):
	x, y, z = es.getindexprop(index, 'CBaseEntity.m_angRotation').split(',')
	es.setindexprop(index, 'CBaseEntity.m_angRotation', '%s,%s,%s'%(float(x) + x_spin, float(y) + y_spin, float(z) + z_spin))
	gamethread.delayedname(0.1, 'spin_ball', spin, index)

def add_sounds():
	if type(custom_sound) == str:
		es.stringtable('downloadables', 'sound/disco/%s'%custom_sound)
	elif custom_sound:
		for a in custom_sound:
			es.stringtable('downloadables', 'sound/disco/%s'%custom_sound)
	for a in downloads:
		es.stringtable('downloadables', 'sound/disco/%s'%a)

def setup_auth(): # Thanks, SD
	global isAuthed
	if services.isRegistered('auth'):
		auth_service = services.use('auth')
		auth_service.registerCapability('disco_admin', auth_service.ADMIN)
		isAuthed = lambda x: auth_service.isUseridAuthorized(x, 'disco_admin')
	else:
		isAuthed = lambda x: False

def return_admins():
	if os.path.isfile(es.getAddonPath('disco').replace('addons/eventscripts/disco', 'cfg/mani_admin_plugin/clients.txt')):
		admins = []
		a = open(es.getAddonPath('disco').replace('addons/eventscripts/disco', 'cfg/mani_admin_plugin/clients.txt'), 'r')
		b = a.readlines()
		a.close()
		c = []
		for a in b:
			a = a.replace('\t', '').replace(' ', '')
			if not a.startswith('//'):
				c.append(a)
		for a in c:
			if a.lower().startswith('"steam""steam_0:'):
				admins.append(a.lower().replace('"steam""', '').replace('"', '').replace('\n', '').upper())
		return admins

def save_data():
	coords_db = open(es.getAddonPath('disco') + '/coords.db', 'w')
	cPickle.dump(coords, coords_db)
	coords_db.close()

def est_map_end(ev):
	if coords.has_key(str(es.ServerVar('eventscripts_currentmap'))):
		if es.getplayercount():
			global admins
			chosen = es.getplayersteamid(random.choice(es.getUseridList()))
			admins.append(chosen)
			x, y, z = coords[str(es.ServerVar('eventscripts_currentmap'))][random.choice(coords[str(es.ServerVar('eventscripts_currentmap'))])]
			es.cexec(es.getuserid(chosen), 'disco %s %s %s'%(x, y, z))
			admins.remove(chosen)

setup_auth()